function [klas,cg]= kmean(x,k,nbessai)
%KMEAN   The k means clustering algorithm
%      KMEANS(x,K,NBESSAI)
%           x       : data nmatrix
%           K       : Number of classes
%           NBESSAI : Number of trials (default=1)
%           cg      : class centers
%           klass   : output class labels (the partition)

if nargin == 2,
  nbessai=1;
end;

[n,p]=size(x);

cgtotal=mean(x,1);

if k==1,
  cg=cgtotal;
  klas=ones(1,n);
else,

w_optimum=Inf;
for essai=1:nbessai,
   disp(['essai ' num2str(essai) ' : ']) 
   % initial partition
   i=randperm(n);
   cg=x(i(1:k),:);
     
   % computation of partition
   D = zeros(k,n);
   for l = 1:k,
      z=(x-ones(n, 1)*cg(l, :)).^2;
      D(l,:)=(sum(z,2))';
   end
   [Dmin,klas]=min(D);
   
   iter=0;
   fin_iter=0;
   w2=inf;

   while ~fin_iter ,
      iter=iter+1;
      % computation of centers
      vide=[];
      w1=0;
      for l=1:k,
         ii=find(klas==l);
         if isempty(ii),
            vide=[vide;i];
         else
            cg(l,:)=mean(x(ii,:),1);
            w1=w1+sum(sum((x(ii,:)-ones(size(ii,2), 1)*cg(l, :)).^2));
         end;
      end;
      cg(vide,:)=[];
      % computation of partition
      k=size(cg,1);
      D = zeros(k,n);
      for l = 1:k,
         D(l,:)=(sum((x-ones(n, 1)*cg(l, :)).^2,2))';
      end
      [Dmin,klas]=min(D);
      w2_old=w2;
      w2=sum(Dmin);
      disp(['Iteration ' num2str(iter)  '     critere :  ' num2str(w1) '    ' num2str(w2)]);
      fin_iter=abs(w2_old-w2)/w2<= 10e-4;
   end;
   if w2 < w_optimum,
      w_optimum=w2;
      cg_optimum=cg;
   end
end
cg=cg_optimum;
% computation of best partition
k=size(cg,1);
D = zeros(k,n);
for l = 1:k,
   D(l,:)=(sum((x-ones(n, 1)*cg(l, :)).^2,2))';
end
[Dmin,klas]=min(D);

end;
